---
title: Introduction to game development for the Web
slug: Games/Introduction
tags:
  - Firefox OS
  - Games
  - Guide
  - Mobile
---
<div>{{GamesSidebar}}</div>

<p>The modern web has quickly become a viable platform not only for creating stunning, high quality games, but also for distributing those games. </p>

<p>The range of games that can be created is on par with desktop and native OS counterparts. With modern Web technologies and a recent browser, it's entirely possible to make stunning, top-notch games for the Web. And we're not talking about simple card games or multi-player social games that have in the olden days been done using Flash®. We're talking about kick-ass 3D action shooters, RPGs, and more. Thanks to massive performance improvements in <a href="/en-US/docs/JavaScript">JavaScript</a> just-in-time compiler technology and new APIs, you can build games that run in the browser (or on <a href="/en-US/docs/HTML/HTML5">HTML5</a>-powered devices like those based on <a href="/en-US/docs/Mozilla/Firefox_OS">Firefox OS</a>) without making compromises.</p>

<h2 id="The_HTML5_game_platform">The HTML5 game platform</h2>

<p>You can truly think of the Web as a better target platform for your game. As we like to say, "the Web is the platform." Let's take a look at the core of the Web platform:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Function</th>
   <th scope="col">Technology</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><strong>Audio</strong></td>
   <td><a href="/en-US/docs/Web_Audio_API">Web Audio API</a></td>
  </tr>
  <tr>
   <td><strong>Graphics</strong></td>
   <td><a href="/en-US/docs/WebGL">WebGL</a> (<a href="http://www.khronos.org/opengles/">OpenGL ES</a> 2.0)</td>
  </tr>
  <tr>
   <td><strong>Input</strong></td>
   <td><a href="/en-US/docs/DOM/Touch_events">Touch events</a>, <a href="/en-US/docs/API/Gamepad/Using_Gamepad_API">Gamepad API</a>, device sensors, <a href="/en-US/docs/WebRTC">WebRTC</a>, <a href="/en-US/docs/DOM/Using_fullscreen_mode">Full Screen API</a>, <a href="/en-US/docs/WebAPI/Pointer_Lock">Pointer Lock API</a></td>
  </tr>
  <tr>
   <td><strong>Language</strong></td>
   <td><a href="/en-US/docs/JavaScript">JavaScript</a> (or C/C++ using <a href="https://github.com/kripken/emscripten/wiki">Emscripten</a> to compile to JavaScript)</td>
  </tr>
  <tr>
   <td><strong>Networking</strong></td>
   <td><a href="/en-US/docs/WebRTC">WebRTC</a> and/or <a href="/en-US/docs/WebSockets">WebSockets</a></td>
  </tr>
  <tr>
   <td><strong>Storage</strong></td>
   <td><a href="/en-US/docs/IndexedDB">IndexedDB</a> or the "cloud"</td>
  </tr>
  <tr>
   <td><strong>Web</strong></td>
   <td><a href="/en-US/docs/HTML">HTML</a>, <a href="/en-US/docs/CSS">CSS</a>, <a href="/en-US/docs/SVG">SVG</a>, <a href="/en-US/docs/Social_API">Social API</a> (and much more!)</td>
  </tr>
 </tbody>
</table>

<h2 id="The_business_case">The business case</h2>

<p>As a game developer, whether you're an individual or a large game studio, you want to know why it makes sense to target the Web with your next game project. Let's look at how the Web can help you.</p>

<ol>
 <li>
  <div>The reach of the Web is enormous; it's everywhere. Games built with HTML5 work on smartphones, tablets, PCs and Smart TVs.</div>
 </li>
 <li>Marketing and discoverability are improved. You're not limited to promoting your app on someone else's app store. Instead, you can advertise and promote your game all over the Web as well as other media, taking advantage of the Web's inherent linkability and shareability to reach new customers.</li>
 <li>You have control where it matters: Payments. You don't have to hand over 30% of your revenues to someone else just because your game is in their ecosystem. Instead, charge what you want and use whatever payment processing service you like.</li>
 <li>Again with more control, you can update your game whenever you want. No waiting breathlessly for approval while someone hidden within another company decides whether or not your critical bug fix will ship today or tomorrow.</li>
 <li>Control your analytics! Instead of relying on someone else to make all the decisions about what analytics you need, you can collect your own -- or choose the third party that you like the best -- to gather information about your sales and your game's reach.</li>
 <li>You get to manage your customer relationship more closely, in your own way. No more having customer feedback filtered through an app store's limited mechanisms. Engage with your customers the way you want to, without a middleman.</li>
 <li>Your players can play your game anywhere, anytime. Because the Web is ubiquitous, your customers can check their game's status on their phones, tablets, their home laptops, their work desktops, or anything else.</li>
</ol>

<h2 id="Web_technologies_for_game_developers">Web technologies for game developers</h2>

<p>For the tech folks, let's dig into the APIs the Web brings to the table that cater to game developers. Here's a thorough list to give you a taste of what the Web can do for you:</p>

<div class="twocolumns">
<dl>
 <dt><a href="/en-US/docs/DOM/Using_fullscreen_mode">Full Screen API</a></dt>
 <dd>This simple API lets your game take over the entire screen, thereby immersing the player in action.</dd>
 <dt><a href="/en-US/docs/API/Gamepad/Using_Gamepad_API">Gamepad API</a></dt>
 <dd>If you want your users to be able to use gamepads or other game controllers to work your game, you'll need this API.</dd>
 <dt><a href="/en-US/docs/HTML">HTML</a> and <a href="/en-US/docs/CSS">CSS</a></dt>
 <dd>Together, these two technologies let you build, style, and lay out your game's user interface. Part of HTML is the {{HTMLElement("canvas")}} element, which provides one way to do 2D graphics.</dd>
 <dt><a href="/en-US/docs/HTML/Element/audio">HTML audio</a></dt>
 <dd>The {{HTMLElement("audio")}} element lets you easily play simple sound effects and music. If your needs are more involved, check out the <a href="/en-US/docs/Web_Audio_API">Web Audio API</a> for real audio processing power!</dd>
 <dt><a href="/en-US/docs/IndexedDB">IndexedDB</a></dt>
 <dd>A powerful data storage API for maintaining user data on their own computer or device. A great way to save game state and other information locally so it doesn't have to be downloaded every time it's needed. Also useful to help make your game playable even when the user isn't connected to the Web (such as when they're stuck on an airplane for hours on end).</dd>
 <dt><a href="/en-US/docs/JavaScript">JavaScript</a></dt>
 <dd>JavaScript, the programming language used on the Web, is blazing fast in modern browsers and getting faster all the time. Use its power to write the code for your game, or look at using technologies like <a href="https://github.com/kripken/emscripten/wiki">Emscripten</a> or <a href="http://asmjs.org/spec/latest/">Asm.js</a> to easily port your existing games.</dd>
 <dt><a href="/en-US/docs/WebAPI/Pointer_Lock">Pointer Lock API</a></dt>
 <dd>The Pointer Lock API lets you lock the mouse or other pointing device within your game's interface so that instead of absolute cursor positioning you receive coordinate deltas that give you more precise measurements of what the user is doing, and prevent the user from accidentally sending their input somewhere else, thereby missing important action.</dd>
 <dt><a href="/en-US/docs/SVG">SVG</a> (Scalable Vector Graphics)</dt>
 <dd>Lets you build vector graphics that scale smoothly regardless of the size or resolution of the user's display.</dd>
 <dt><a href="/en-US/docs/JavaScript/Typed_arrays">Typed Arrays</a></dt>
 <dd>JavaScript typed arrays give you access to raw binary data from within JavaScript; this lets you manipulate GL textures, game data, or anything else, even if it's not in a native JavaScript format.</dd>
 <dt><a href="/en-US/docs/Web_Audio_API">Web Audio API</a></dt>
 <dd>This API for controlling the playback, synthesis, and manipulation of audio from JavaScript code lets you create awesome sound effects as well as play and manipulate music in real time.</dd>
 <dt><a href="/en-US/docs/WebGL">WebGL</a></dt>
 <dd>Lets you create high-performance, hardware-accelerated 3D (and 2D) graphics from Web content. This is a Web-supported implementation of <a href="http://www.khronos.org/opengles/">OpenGL ES</a> 2.0.</dd>
 <dt><a href="/en-US/docs/WebRTC">WebRTC</a></dt>
 <dd>The WebRTC (Real-Time Communications) API gives you the power to control audio and video data, including teleconferencing and transmitting other application data back and forth between two users. Want your players to be able to talk to each other while blowing up monsters? This is the API for you.</dd>
 <dt><a href="/en-US/docs/WebSockets">WebSockets</a></dt>
 <dd>The WebSocket API lets you connect your app or site to a server to transmit data back and forth in real-time. Perfect for multiplayer gaming action, chat services, and so forth.</dd>
 <dt><a href="/en-US/docs/DOM/Using_web_workers">Web Workers</a></dt>
 <dd>Workers give you the ability to spawn background threads running their own JavaScript code, to take advantage of modern, multi-core processors.</dd>
 <dt><a href="/en-US/docs/DOM/XMLHttpRequest">XMLHttpRequest</a> and <a href="/en-US/docs/Web/API/File_and_Directory_Entries_API" title="/en-US/docs/DOM/File_API">File API</a></dt>
 <dd>The combination of XMLHttpRequest and the File API lets you send and receive any kind of data you want (don't let the "XML" throw you!) from a Web server. This is a great way to do anything from downloading new game levels and artwork to transmitting non-real-time game status information back and forth.</dd>
</dl>
</div>
